<!--
 ~ Copyright (c) 2005-2010, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 ~
 ~ WSO2 Inc. licenses this file to you under the Apache License,
 ~ Version 2.0 (the "License"); you may not use this file except
 ~ in compliance with the License.
 ~ You may obtain a copy of the License at
 ~
 ~    http://www.apache.org/licenses/LICENSE-2.0
 ~
 ~ Unless required by applicable law or agreed to in writing,
 ~ software distributed under the License is distributed on an
 ~ "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 ~ KIND, either express or implied.  See the License for the
 ~ specific language governing permissions and limitations
 ~ under the License.
 -->
<%@ page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@ page import="java.io.PrintWriter" %>
<%@ page import="org.apache.commons.logging.LogFactory" %>
<%@ page import="org.apache.commons.logging.Log" %>
<%@ page import="javax.xml.transform.Result" %>
<%@ page import="javax.xml.transform.stream.StreamResult" %>
<%@ page import="org.wso2.carbon.wsdl2form.WSDL2FormGenerator" %>
<%@ page import="org.wso2.carbon.CarbonException" %>
<%@ page import="org.wso2.carbon.CarbonConstants" %>
<%@ page import="org.apache.axis2.context.ConfigurationContext" %>
<%
    String backendServerURL = CarbonUIUtil.getServerURL(config.getServletContext(), session);
    String taskId = request.getParameter("taskId");
    String tryitServiceName = request.getParameter("tryitServiceName");
    String tryitOperationName = request.getParameter("tryitOperationName");
    String tryitWsdlUrl = backendServerURL + tryitServiceName + "?wsdl2";
    ConfigurationContext configContext =
            (ConfigurationContext) config.getServletContext().
                    getAttribute(CarbonConstants.CONFIGURATION_CONTEXT);

    Log log = LogFactory.getLog("tryit.ajaxprocessor");

    request.setCharacterEncoding("UTF-8");
    // Set content to xml
    response.setContentType("text/xml; charset=UTF-8");
    // Set standard HTTP/1.1 no-cache headers.
    response.setHeader("Cache-Control",
            "no-store, max-age=0, no-cache, must-revalidate");

    // Set IE extended HTTP/1.1 no-cache headers.
    response.addHeader("Cache-Control", "post-check=0, pre-check=0");

    // Set standard HTTP/1.0 no-cache header.
    response.setHeader("Pragma", "no-cache");

    PrintWriter printWriter = response.getWriter();

    try {
        Result result = new StreamResult(printWriter);
        //TODO get the correct ConfigurationContext i.e. to be tenant aware
        String str = WSDL2FormGenerator.getInstance().
                getInternalMockit(result, configContext, tryitWsdlUrl, tryitServiceName, tryitOperationName,
                        taskId, "/carbon/humantask/task_dispatch-ajaxprocessor.jsp", false);
        if(!str.equals(WSDL2FormGenerator.SUCCESS)) {
            log.info("ReDirecting to " + str);
            response.sendRedirect(str);
        }
    } catch (CarbonException e) {
        log.error(e);
        response.setContentType("text/html; charset=utf-8");
        if (e.getMessage().equals(WSDL2FormGenerator.SERVICE_INACTIVE)) {
            response.setStatus(HttpServletResponse.SC_NOT_FOUND);
            printWriter
                    .write(("<h4>Requested Service is inactive. Cannot generate stubs.</h4>"));
            printWriter.flush();
            return;
        } else if (e.getMessage().equals(WSDL2FormGenerator.SERVICE_NOT_FOUND)) {
            response.setStatus(HttpServletResponse.SC_SERVICE_UNAVAILABLE);
            printWriter
                    .write(("<h4>Service cannot be found. Cannot display <em>Stub</em>.</h4>"));
            printWriter.flush();
            return;
        } else {
            response.sendError(HttpServletResponse.SC_NOT_FOUND);
            response.setContentType("text/html; charset=utf-8");
            printWriter.write(
                    ("<h4>" + e.getMessage() + "</h4>"));
            printWriter.flush();
            return;
        }
    }
    printWriter.flush();

%>
